#include"glms_applet.h"

static  double temp2, temp3, temp1, in0, in1, in3, in2, in6, in4, in5;
static  int multiple_lm75 = 0;
static  double fan1, fan2, fan3, act;
static  double alrms;
static  char tempScale[2] = "C";
static double proctemp;
static double procfan;
static double dualtemp;
static double dualfan;
//static short tooltipholder = 0; // ugly solution

GtkWidget *applet;

static void glms_properties(AppletWidget*,gpointer);


typedef struct
{
    GtkWidget *label;
    GtkWidget *GLMSapplet;

    int mode;
    int value;
    int timeouttime;
    int timeout;
    int update_rate,update_hold;
    int show_fans,fans_hold;
    int show_voltage,voltage_hold;
    int show_tooltip,tooltip_hold;
    int fahrenheits, fahrenheit_hold;
    int proc_temp,proc_temp_hold;
    int proc_fan, proc_fan_hold;
    int show_dual, dual_hold;
    int dual_temp, dual_temp_hold;
    int dual_fan, dual_fan_hold;
    int change;
} utData;

void log_msg(char *str)
{
    FILE *log_file;
    char home[255];

    strcpy(home,getenv("HOME"));
    strcat(home,"/.glms_log");
    if((log_file=fopen(home,"a"))!=NULL)
    { fprintf(log_file,"%s",str);
        fclose(log_file);
    }
}


void toF()
{
    temp1 = (( (temp1 *9)/5) + 32);
    temp2 = (( (temp2 *9)/5) + 32);
    temp3 = (( (temp3 *9)/5) + 32);
    proctemp = (( (proctemp *9)/5) + 32);

}

void applet_clicked_cb(utData *utd)
{       char print_glms_str[256];
 //   char print_glms_str[256];
    strcpy(print_glms_str, "appletclicked");
    gtk_label_set_text(GTK_LABEL(utd->label),print_glms_str);

}
static void about_cb(AppletWidget *widget, gpointer data)
{
    GtkWidget *about;
    static const gchar *author[]={"orangutan (orangutan@slo.net)",NULL};

    about=gnome_about_new(_("Hardware monitoring Applet \n\
                        using lm_sensors"),
                      VERSION,
                      "(C) 1999 the Free Software Foundation",
                      author,
                      _("Display your system hardware state\n\
                        eg.:procesor temperature, procesor cooling fan speed,\n\
                        voltage state , ..."),
                      NULL);

     gtk_widget_show(about);
} /* about_cb */

void set_tooltip(utData *utd )
{
    char tooltip_msg[512];

    //    printf("toolt proctemp:%d temp1:%f temp2:%f temp3:%f\n", proctemp,temp1,temp2,temp3);
    if (utd->show_tooltip == 1)

        sprintf(tooltip_msg,"V1Core: %2.2f V\nV2Core: %2.2f V\nProc temp:%.0f%s\n+V3.3: %1.2fV\n+5V: %1.2fV\n+V12: %2.2fV\n-V12: %2.2fV\n-V5: %1.2fV",in0, in1, proctemp,tempScale,in2,in3,in4,in5,in6);

    else
        sprintf(tooltip_msg,"");

    applet_widget_set_tooltip(APPLET_WIDGET(applet),tooltip_msg);

}

int get_lms()
{
    int res;
    open_config_file(); /* Now we must initialise the sensors library */
    if ((res = sensors_init(config_file)))
    {
        if (res == SENSORS_ERR_PROC)
            fprintf(stderr,
                    "/proc/sys/dev/sensors/chips or /proc/bus/i2c unreadable:\n"
                    "Make sure you have inserted modules sensors.o and i2c-proc.o!");
        else
            fprintf(stderr,"%s\n",sensors_strerror(res));
        return -1;
    }
    GetLm(&temp2, &temp3, &temp1, &in0, &in1, &in2, &in3, &in6, &in4, &in5, &fan1, &fan2, &fan3, multiple_lm75, &alrms);
    return 1;
}


static void glms_update_func(utData *utd)
{
    char print_glms_str[256];
    char tmp_str[255];
    char tmp_msg[255];
    int curr,sec,min,hour,day;


    GetLm(&temp2, &temp3, &temp1, &in0, &in1, &in2, &in3, &in6, &in4, &in5, &fan1, &fan2, &fan3, multiple_lm75, &alrms);
    if (utd->fahrenheits)
    {
        toF();
    }
    //    get_lms();

    // prevent incrementing on properties change alone
    if(utd->change==FALSE)
    {
        utd->value=utd->value+utd->update_rate;
    }
    curr=utd->value;


    /* implement any changes from properties here, as to
     avoid screwing up the current update period*/
    if(utd->change==TRUE)
    {
        utd->update_rate=utd->update_hold;
        utd->show_fans=utd->fans_hold;
        utd->show_voltage=utd->voltage_hold;
        utd->proc_temp=utd->proc_temp_hold;
        utd->show_tooltip=utd->tooltip_hold;
        utd->proc_temp=utd->proc_temp_hold;
        utd->proc_fan=utd->proc_fan_hold;
        utd->show_dual=utd->dual_hold;
        utd->dual_temp=utd->dual_temp_hold;
        utd->dual_fan=utd->dual_fan_hold;
        utd->fahrenheits=utd->fahrenheit_hold;
        utd->change=FALSE;
    }

    if (utd->proc_temp == 1)
    {
        proctemp = temp1;
    }
    else if (utd->proc_temp == 2)
    {
        proctemp = temp2;
    }
    else
    {
        proctemp = temp3 ;
    }





    sprintf(tmp_msg, "CPU temp: %.0f",proctemp);

    if(utd->show_dual )
    {
        if (utd->dual_temp == 1)
        {
            dualtemp = temp1;
        }
        else if (utd->proc_temp == 2)
        {
            dualtemp = temp2;
        }
        else
        {
            dualtemp = temp3 ;
        }

        if (utd->dual_fan == 1)
        {
            dualfan= fan1;
        }
        else if (utd->dual_fan == 2)
        {
            dualfan = fan2;
        }
        else
        {
            dualfan = fan3;
        }

        if (utd->fahrenheits)
        {
            toF();
            strcpy(tempScale," F");
            sprintf(tmp_str, " - %.0f %s",dualtemp,tempScale);
            strcat(tmp_msg,tmp_str);
        }
        else
        {
            strcpy(tempScale," C");
            sprintf(tmp_str, " - %.0f %s",dualtemp,tempScale);
            strcat(tmp_msg,tmp_str);
        }
        strcpy(tmp_str,"");
    }


    else //if not dual
    {

        if (utd->fahrenheits)
        {
            toF();
            strcpy(tempScale," F");
        }
        else
        {
            strcpy(tempScale,"C");
        }

        strcat(tmp_msg,tempScale);
    }


    if(utd->show_fans==1)
    {

        if (utd->proc_fan == 1)
        {
            procfan = fan1;
        }
        else if (utd->proc_fan == 2)
        {
            procfan = fan2;
        }
        else
        {
            procfan = fan3 ;
        }

        sprintf(tmp_str, "\n%4.0f",procfan);

        strcat(tmp_msg,tmp_str);

        if (utd->show_dual == 1)
        {

            sprintf(tmp_str, " - %4.0f",dualfan);
            strcat(tmp_msg,tmp_str);

        }
        strcat(tmp_msg, "RPM");
        strcpy(tmp_str, "");
    }

    if (utd->show_voltage)
    {
        sprintf(tmp_str,"\nVcore: %.2f",in0);
        strcat(tmp_msg,tmp_str);

    }
    strcpy(print_glms_str,tmp_msg);



    gtk_label_set_text(GTK_LABEL(utd->label),print_glms_str);
    set_tooltip(utd);
} /* glms_update_func */




static int glms_callback(gpointer data)
{
    utData *utd=data;

    glms_update_func(utd);

    /* kept in seconds, actual in milliseconds */
    if(utd->timeouttime!=(utd->update_rate*1000))
    {
        utd->timeouttime=(utd->update_rate*1000);
        utd->timeout=gtk_timeout_add(utd->timeouttime,glms_callback,utd);
        return FALSE;
    }

    return TRUE;
} /* glms_callback */

static gint applet_save_session(GtkWidget *w,
                                const char *privcfgpath,
                                const char *globcfgpath,
                                gpointer data)
{
    utData *utd=data;

    gnome_config_push_prefix(privcfgpath);

    gnome_config_set_int("glms/update_rate",utd->update_rate);
    gnome_config_set_int("glms/show_fans",utd->show_fans);
    gnome_config_set_int("glms/show_voltage",utd->show_voltage);
    gnome_config_set_int("glms/show_tooltip",utd->show_tooltip);
    gnome_config_set_int("glms/fahrenheits",utd->fahrenheits);
    gnome_config_set_int("glms/proc_temp",utd->proc_temp);
    gnome_config_set_int("glms/proc_fan",utd->proc_fan);
    gnome_config_set_int("glms/show_dual",utd->show_dual);
    gnome_config_set_int("glms/dual_temp",utd->dual_temp);
    gnome_config_set_int("glms/dual_fan",utd->dual_fan);
    gnome_config_pop_prefix();
    gnome_config_sync();
    gnome_config_drop_all();

    return FALSE;
} /* applet_save_session */

static void load_properties(utData *utd)
{
    char str[20];

    log_msg("properties loaded\n");

    utd->update_rate=gnome_config_get_int("glms_applet/glms/update_rate=60");
    utd->show_fans=gnome_config_get_int("glms_applet/glms/show_fans=1");
    utd->show_voltage=gnome_config_get_int("glms_applet/glms/show_voltage=0");
    utd->show_tooltip=gnome_config_get_int("glms_applet/glms/show_tooltip=1");
    utd->fahrenheits=gnome_config_get_int("glms_applet/glms/fahrenheits=0");
    utd->proc_temp=gnome_config_get_int("glms_applet/glms/proc_temp=2");
    utd->proc_fan=gnome_config_get_int("glms_applet/glms/proc_fan=1");
    utd->show_dual=gnome_config_get_int("glms_applet/glms/show_dual=0");
    utd->dual_temp=gnome_config_get_int("glms_applet/glms/dual_temp=2");
    utd->dual_fan=gnome_config_get_int("glms_applet/glms/dual_fan=1");
    sprintf(str,"show_fans=%d\n",utd->show_fans);
    log_msg(str);
} /* load_properties */

GtkWidget *set_text_display(utData *utd)
{
    GtkWidget *align;
    GtkWidget *vbox;
    GtkWidget *hbox;
    GtkWidget *label;
    GtkWidget *frame;

    frame=gtk_frame_new(NULL);
    gtk_frame_set_shadow_type(GTK_FRAME(frame),GTK_SHADOW_IN);

    align=gtk_alignment_new(0.5,0.5,0.0,0.0);
    gtk_container_set_border_width(GTK_CONTAINER(align),4);
    gtk_container_add(GTK_CONTAINER(frame),align);
    gtk_widget_show(align);

    vbox=gtk_vbox_new(FALSE,FALSE);
    gtk_container_add(GTK_CONTAINER(align),vbox);
    gtk_widget_show(vbox);


    glms_update_func(utd);      /* explicit call to display first value */
    gtk_widget_show(utd->label);
    gtk_box_pack_start(GTK_BOX(vbox),utd->label,TRUE,TRUE,0);

    hbox=gtk_hbox_new(FALSE,FALSE);
    gtk_box_pack_start_defaults(GTK_BOX(vbox),hbox);
    gtk_widget_show(hbox);

    return frame;
} /* set_text_display */

static GtkWidget *create_glms_applet(GtkWidget *window,utData *utd)
{
    GtkWidget *frame;
    char str[20];

    /* initialize data strucuture */
    utd=g_new(utData,1);
    utd->label=gtk_label_new("");
    utd->mode=TEXT_MODE;

    utd->update_rate=DEFAULT_UPDATE;
    utd->update_hold=DEFAULT_UPDATE;
    utd->show_fans=DEFAULT_FANS;
    utd->fans_hold=DEFAULT_FANS;
    utd->show_voltage=DEFAULT_VOLTAGE;
    utd->voltage_hold=DEFAULT_VOLTAGE;
    utd->show_tooltip=DEFAULT_TOOLTIP;
    utd->tooltip_hold=DEFAULT_TOOLTIP;
    utd->fahrenheits=DEFAULT_FAHRENHEITS;
    utd->fahrenheit_hold=DEFAULT_FAHRENHEITS;
    utd->proc_temp = DEFAULT_PROC_TEMP;
    utd->proc_temp_hold=DEFAULT_PROC_TEMP;
    utd->proc_fan=DEFAULT_PROC_FAN;
    utd->proc_fan_hold=DEFAULT_PROC_FAN;
    utd->show_dual=DEFAULT_SHOW_DUAL;
    utd->dual_hold=DEFAULT_SHOW_DUAL;
    utd->dual_temp_hold=DEFAULT_DUAL_TEMP;
    utd->dual_temp=DEFAULT_DUAL_TEMP;
    utd->dual_fan=DEFAULT_DUAL_FAN;
    utd->dual_fan_hold=DEFAULT_DUAL_FAN;
    utd->change=FALSE;
    utd->timeouttime=(utd->update_rate*1000);
    utd->timeout=gtk_timeout_add(utd->timeouttime,glms_callback,utd);

    load_properties(utd);

    frame =set_text_display(utd);

    gtk_signal_connect(GTK_OBJECT(applet),"save_session",
                       GTK_SIGNAL_FUNC(applet_save_session),
                       utd);

    applet_widget_register_stock_callback(APPLET_WIDGET(applet),
                                          "about",
                                          GNOME_STOCK_MENU_ABOUT,
                                          _("About..."),
                                          about_cb,
                                          NULL);

    applet_widget_register_stock_callback(APPLET_WIDGET(applet),
                                          "properties",
                                          GNOME_STOCK_MENU_PROP,
                                          _("Properties..."),
                                          glms_properties,
                                          utd);




    /* putting this code here gets it to work... go figure */
    gnome_config_push_prefix(APPLET_WIDGET(applet)->privcfgpath);
    utd->update_rate=gnome_config_get_int("glms/update_rate=1");
    utd->show_fans=gnome_config_get_int("glms/show_fans=1");
    utd->show_voltage=gnome_config_get_int("glms/show_voltage=0");
    utd->show_tooltip=gnome_config_get_int("glms/show_tooltip=1");
    utd->fahrenheits=gnome_config_get_int("glms/fahrenheits=0");
    utd->proc_temp=gnome_config_get_int("glms/proc_temp=2");
    utd->proc_fan=gnome_config_get_int("glms/proc_fan=1");
    utd->show_dual=gnome_config_get_int("glms/show_dual=0");
    utd->dual_temp=gnome_config_get_int("glms/dual_temp=2");
    utd->dual_fan=gnome_config_get_int("glms/dual_fan=1");
    sprintf(str,"show_fans=%d\n",utd->show_fans);
    log_msg(str);

    /* apply properties */
    glms_update_func(utd);

    return frame;
} /* create_glms_panel */

int main(int argc, char **argv)
{
    GtkWidget *glms;
    utData *utd=NULL;

    /* initialize i18n stuph */
    bindtextdomain(PACKAGE, GNOMELOCALEDIR);
    textdomain(PACKAGE);
    get_lms();
    applet_widget_init("glms_applet",VERSION,argc,argv,NULL,0,NULL);

    applet =applet_widget_new("glms_applet");
    if(!applet)
    {
        g_print("Cannot create applet!\n");
        _exit(127);
    }

    
    gtk_widget_realize(applet);

    glms=create_glms_applet(applet,utd);
    gtk_widget_show(glms);
         	gtk_widget_set_events(applet, gtk_widget_get_events(applet) |
                              GDK_BUTTON_PRESS_MASK);

       	gtk_signal_connect(GTK_OBJECT(applet), "button_press_event",
			   GTK_SIGNAL_FUNC(applet_clicked_cb), utd);
    applet_widget_add(APPLET_WIDGET(applet),glms);
    gtk_widget_show(applet);
     
    applet_widget_gtk_main();

    return 0;
} /* main */

/*************** properties *******************/

static void close_properties(GtkWidget *widget,GtkWidget **prop)
{
    *prop=NULL;
} /* close_properties */

static void apply_properties(GtkWidget *widget,gint button_num,gpointer data)
{
    utData *utd=data;

    /* hold values are used because updating the actual values
     directly would cause the change to take effect before apply
     was pressed (for some reason I couldn't fathom). this circumvented
     the problem */
    utd->change=TRUE;

    /* interrupt current timeout and start over, updating display */
    gtk_timeout_remove(utd->timeout);
    utd->timeout=gtk_timeout_add(utd->timeouttime,glms_callback,utd);

    glms_update_func(utd);
    utd->timeouttime=(utd->update_rate*1000);
} /* apply properties */

static void cb_adj(GtkAdjustment *adj,gint *new_val)
{ GtkWidget *props;

  props=gtk_object_get_data(GTK_OBJECT(adj),"prop");

  if(props)
    { gnome_property_box_changed(GNOME_PROPERTY_BOX(props));
    }
  *new_val=(gint)(adj->value);
} /* cb_adj */

static void cb_check(GtkWidget *widget,gint *new_val)
{
    GtkWidget *props;

    props=gtk_object_get_data(GTK_OBJECT(widget),"prop");
    if(props)
    {
        gnome_property_box_changed(GNOME_PROPERTY_BOX(props));
    }

    if(GTK_TOGGLE_BUTTON(widget)->active)
        *new_val=1;
    else
        *new_val=0;
} /* cb_check */

static void glms_properties(AppletWidget *applet,gpointer data)
{
    static GnomeHelpMenuEntry help_entry={NULL,"topic.dat"};

  static GtkWidget *props=NULL;
  GtkWidget *hbox;
  GtkWidget *vbox;
  GtkWidget *align;
  GtkWidget *entry;
  GtkWidget *label;
  GtkWidget *showdate;
  GtkWidget *unixtime;
  GtkAdjustment *adj;
  utData *utd=data;

  help_entry.name=gnome_app_id;

  if(props) 
    { gtk_widget_show(props);
      if(props->window)
	gdk_window_raise(props->window);
      return;
    }

  props=gnome_property_box_new();  
  gtk_signal_connect(GTK_OBJECT(props),"apply",
		     GTK_SIGNAL_FUNC(apply_properties),data);
  gtk_signal_connect(GTK_OBJECT(props),"destroy",
		     GTK_SIGNAL_FUNC(close_properties),&props);
  gtk_signal_connect(GTK_OBJECT(props),"help",
		     GTK_SIGNAL_FUNC(gnome_help_pbox_display),&help_entry);

  gtk_window_set_title(GTK_WINDOW(props),_("glms properties"));
  hbox=gtk_hbox_new(FALSE,GNOME_PAD);
  vbox=gtk_vbox_new(FALSE,GNOME_PAD);



  /* create update-rate entry field */
  adj=(GtkAdjustment *)gtk_adjustment_new((gfloat)(utd->update_rate),
					  UPDATE_LOW,UPDATE_HIGH,
					  1,10,UNUSED);
  entry=gtk_spin_button_new(adj,1,0);
  gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(entry),TRUE);
  gtk_signal_connect(GTK_OBJECT(adj),"value_changed",
		     GTK_SIGNAL_FUNC(cb_adj),&utd->update_hold);
  gtk_object_set_data(GTK_OBJECT(adj),"prop",props);
  label=gtk_label_new(_("Update time (seconds)"));
  gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
  gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,0);
  gtk_widget_show(label);
  gtk_widget_show(entry);

//  entry=gtk_spin_button_new(adj,1,0);
//  gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(entry),TRUE);

  gtk_object_set_data(GTK_OBJECT(adj),"prop",props);
  gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,15);
  gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,0);
  gtk_widget_show(label);
  gtk_widget_show(entry);

  /* pack hbox into vbox, the final product */
  gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
  gtk_widget_show(hbox);
  
  /* next hbox */
  hbox=gtk_hbox_new(FALSE,GNOME_PAD);

  /* create show-seconds toggle box */
  entry=gtk_check_button_new_with_label(_("Show CPU cooling fan"));
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry),utd->show_fans);
  gtk_signal_connect(GTK_OBJECT(entry),"toggled",
		     GTK_SIGNAL_FUNC(cb_check),&utd->fans_hold);
  gtk_object_set_data(GTK_OBJECT(entry),"prop",props);
  gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,0);
  gtk_widget_show(entry);

  /* create show-voltage toggle box */
  entry=gtk_check_button_new_with_label(_("Show procesor voltage"));
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry),utd->show_voltage);
  gtk_signal_connect(GTK_OBJECT(entry),"toggled",
		     GTK_SIGNAL_FUNC(cb_check),&utd->voltage_hold);
  gtk_object_set_data(GTK_OBJECT(entry),"prop",props);
  gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,80);
  gtk_widget_show(entry);

  /* pack another hbox into vbox, the final product */
  gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
  gtk_widget_show(hbox);

      hbox=gtk_hbox_new(FALSE,GNOME_PAD);
   /* create show_tooltip toggle box */
    entry=gtk_check_button_new_with_label(_("enable tooltip info"));
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry),utd->show_tooltip);
    gtk_signal_connect(GTK_OBJECT(entry),"toggled",
                       GTK_SIGNAL_FUNC(cb_check),&utd->tooltip_hold);
    gtk_object_set_data(GTK_OBJECT(entry),"prop",props);
    gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,0);
    gtk_widget_show(entry);

    /* pack hbox into vbox, the final product */
    gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
    gtk_widget_show(hbox);

        entry=gtk_check_button_new_with_label(_("fahrenheit scale?"));
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry),utd->fahrenheits);
    gtk_signal_connect(GTK_OBJECT(entry),"toggled",
                       GTK_SIGNAL_FUNC(cb_check),&utd->fahrenheit_hold);
    gtk_object_set_data(GTK_OBJECT(entry),"prop",props);
    gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,0);
    gtk_widget_show(entry);

    /* pack hbox into vbox, the final product */
    gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
    gtk_widget_show(hbox);

    gtk_widget_show(hbox);

    /* channel selector*/
    hbox=gtk_hbox_new(FALSE,GNOME_PAD);
      adj=(GtkAdjustment *)gtk_adjustment_new((gfloat)(utd->proc_temp),
					  1,3,
					  1,10,UNUSED);
  entry=gtk_spin_button_new(adj,1,0);
  gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(entry),TRUE);
  gtk_signal_connect(GTK_OBJECT(adj),"value_changed",
		     GTK_SIGNAL_FUNC(cb_adj),&utd->proc_temp_hold);
  gtk_object_set_data(GTK_OBJECT(adj),"prop",props);
  label=gtk_label_new(_("temperature channel selector"));
  gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
  gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,0);
  gtk_widget_show(label);
  gtk_widget_show(entry);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
  gtk_widget_show(hbox);

    hbox=gtk_hbox_new(FALSE,GNOME_PAD);
      adj=(GtkAdjustment *)gtk_adjustment_new((gfloat)(utd->proc_fan),
					  1,3,
					  1,10,UNUSED);
  entry=gtk_spin_button_new(adj,1,0);
  gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(entry),TRUE);
  gtk_signal_connect(GTK_OBJECT(adj),"value_changed",
		     GTK_SIGNAL_FUNC(cb_adj),&utd->proc_fan_hold);
  gtk_object_set_data(GTK_OBJECT(adj),"prop",props);
  label=gtk_label_new(_("fan channel selector"));
  gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
  gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,0);
  gtk_widget_show(label);
  gtk_widget_show(entry);

  //  entry=gtk_spin_button_new(adj,1,0);
//  gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(entry),TRUE);

  gtk_object_set_data(GTK_OBJECT(adj),"prop",props);
  gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,15);
  gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,0);
  gtk_widget_show(label);
  gtk_widget_show(entry);
  gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
  gtk_widget_show(hbox);

  hbox=gtk_hbox_new(FALSE,GNOME_PAD);
  entry=gtk_check_button_new_with_label(_("dual proccesors system ?"));
  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(entry),utd->show_dual);
  gtk_signal_connect(GTK_OBJECT(entry),"toggled",
                     GTK_SIGNAL_FUNC(cb_check),&utd->dual_hold);
  gtk_object_set_data(GTK_OBJECT(entry),"prop",props);
  gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,0);
  gtk_widget_show(entry);
  
//  gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
//  gtk_widget_show(hbox);

    /* pack hbox into vbox, the final product */
  gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
  gtk_widget_show(hbox);

    adj=(GtkAdjustment *)gtk_adjustment_new((gfloat)(utd->dual_temp),
                                            1,3,
                                            1,10,UNUSED);
    entry=gtk_spin_button_new(adj,1,0);
    gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(entry),TRUE);
    gtk_signal_connect(GTK_OBJECT(adj),"value_changed",
                       GTK_SIGNAL_FUNC(cb_adj),&utd->dual_temp_hold);
    gtk_object_set_data(GTK_OBJECT(adj),"prop",props);
    label=gtk_label_new(_("second procesor temperature channel ?"));
    gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,0);
    gtk_widget_show(label);
    gtk_widget_show(entry);

    gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
    gtk_widget_show(hbox);
 gtk_widget_show(hbox);

    adj=(GtkAdjustment *)gtk_adjustment_new((gfloat)(utd->dual_fan),
                                            1,3,
                                            1,10,UNUSED);
    entry=gtk_spin_button_new(adj,1,0);
    gtk_spin_button_set_numeric(GTK_SPIN_BUTTON(entry),TRUE);
    gtk_signal_connect(GTK_OBJECT(adj),"value_changed",
                       GTK_SIGNAL_FUNC(cb_adj),&utd->dual_fan_hold);
    gtk_object_set_data(GTK_OBJECT(adj),"prop",props);
    label=gtk_label_new(_("second procesor fan channel ?"));
    gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,0);
    gtk_box_pack_start(GTK_BOX(hbox),entry,FALSE,FALSE,0);
    gtk_widget_show(label);
    gtk_widget_show(entry);

    gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
    gtk_widget_show(hbox);
    /* show the resulting box */
  gtk_widget_show(vbox);

  gnome_property_box_append_page(GNOME_PROPERTY_BOX(props),vbox,gtk_label_new(_("GLMS")));

  gtk_widget_show(props);
} /* glms_properties */
